OpenTTD Source: IndustryCargoesWindow Struct Reference

OpenTTD Source 15.0-beta1

Public Types | Public Member Functions | Static Public Member Functions | Data Fields
IndustryCargoesWindow Struct Reference

Window displaying the cargo connections around an industry (or cargo). More...

Inheritance diagram for IndustryCargoesWindow:

## Public Types
typedef std::vector< CargoesRow > | Fields
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.

## Public Member Functions
| IndustryCargoesWindow (int id)
void | OnInit () override
| Notification that the nested widget tree gets initialized.
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | SetStringParameters (WidgetID widget) const override
| Initialize string parameters for a widget.
void | ShortenCargoColumn (int column, int top, int bottom)
| Shorten the cargo column to just the part between industries.
void | PlaceIndustry (int row, int col, IndustryType it)
| Place an industry in the fields.
void | NotifySmallmap ()
| Notify smallmap that new displayed industries have been selected (in _displayed_industries).
void | ComputeIndustryDisplay (IndustryType displayed_it)
| Compute what and where to display for industry type it.
void | ComputeCargoDisplay (CargoID cid)
| Compute what and where to display for cargo id cid.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
bool | CalculatePositionInWidget (Point pt, Point *fieldxy, Point *xy)
| Calculate in which field was clicked, and within the field, at what position.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnDropdownSelect (WidgetID widget, int index) override
| A dropdown option associated to this window has been selected.
bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond) override
| Event to display a custom tooltip.
void | OnResize () override
| Called after the window got resized.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
template<typename T , std::enable_if_t< std::is_base_of< StrongTypedefBase, T >::value, int > = 0>
void | FinishInitNested (T number)
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual void | OnQueryTextFinished (std::optional< std::string > str)
| The query window opened from this window has closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Static Public Member Functions
static bool | HasCommonValidCargo (const std::span< const CargoID > cargoes1, const std::span< const CargoID > cargoes2)
| Do the two sets of cargoes have a valid cargo in common?
static bool | HousesCanSupply (const std::span< const CargoID > cargoes)
| Can houses be used to supply one of the cargoes?
static bool | HousesCanAccept (const std::span< const CargoID > cargoes)
| Can houses be used as customers of the produced cargoes?
static int | CountMatchingAcceptingIndustries (const std::span< const CargoID > cargoes)
| Count how many industries have accepted cargoes in common with one of the supplied set.
static int | CountMatchingProducingIndustries (const std::span< const CargoID > cargoes)
| Count how many industries have produced cargoes in common with one of the supplied set.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.

## Data Fields
Fields | fields
| Fields to display in the WID_IC_PANEL.
uint | ind_cargo
| If less than NUM_INDUSTRYTYPES, an industry type, else a cargo id + NUM_INDUSTRYTYPES.
Dimension | cargo_textsize
| Size to hold any cargo text, as well as STR_INDUSTRY_CARGOES_SELECT_CARGO.
Dimension | ind_textsize
| Size to hold any industry type text, as well as STR_INDUSTRY_CARGOES_SELECT_INDUSTRY.
Scrollbar * | vscroll
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
int | scale
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8_t | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root
| Root of the nested tree.
WidgetLookup | widget_lookup
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget
| ID of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
WindowList::iterator | z_position

## Additional Inherited Members
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize
| Set if window has been resized.

## Detailed Description

Window displaying the cargo connections around an industry (or cargo).

The main display is constructed from 'fields', rectangles that contain an industry, piece of the cargo connection, cargo labels, or headers. For a nice display, the following should be kept in mind:

- A CFT_HEADER is always at the top of an column of CFT_INDUSTRY fields.
- A CFT_CARGO_LABEL field is also always put in a column of CFT_INDUSTRY fields.
- The top row contains CFT_HEADER and CFT_SMALL_EMPTY fields.
- Cargo connections have a column of their own (CFT_CARGO fields).
- Cargo accepted or produced by an industry, but not carried in a cargo connection, is drawn in the space of a cargo column attached to the industry. The information however is part of the industry.

This results in the following invariants:

- Width of a CFT_INDUSTRY column is large enough to hold all industry type labels, all cargo labels, and all header texts.
- Height of a CFT_INDUSTRY is large enough to hold a header line, or a industry type line, `N` cargo labels (where `N` is the maximum number of cargoes connected between industries), `N` connections of cargo types, and space between two industry types (1/2 above it, and 1/2 underneath it).
- Width of a cargo field (CFT_CARGO) is large enough to hold `N` vertical columns (one for each type of cargo). Also, space is needed between an industry and the leftmost/rightmost column to draw the non-carried cargoes.
- Height of a CFT_CARGO field is equally high as the height of the CFT_INDUSTRY.
- A field at the top (CFT_HEADER or CFT_SMALL_EMPTY) match the width of the fields below them (CFT_INDUSTRY respectively CFT_CARGO), the height should be sufficient to display the header text.

When displaying the cargoes around an industry type, five columns are needed (supplying industries, accepted cargoes, the industry, produced cargoes, customer industries). Displaying the industries around a cargo needs three columns (supplying industries, the cargo, customer industries). The remaining two columns are set to CFT_EMPTY with a width equal to the average of a cargo and an industry column.

Definition at line 2560 of file industry_gui.cpp.

## Member Typedef Documentation

## ◆ Fields

typedef std::vector<CargoesRow> IndustryCargoesWindow::Fields

Definition at line 2561 of file industry_gui.cpp.

## Constructor & Destructor Documentation

## ◆ IndustryCargoesWindow()

IndustryCargoesWindow::IndustryCargoesWindow | ( | int | id | ) |
| inline

Definition at line 2569 of file industry_gui.cpp.

## Member Function Documentation

## ◆ CalculatePositionInWidget()

bool IndustryCargoesWindow::CalculatePositionInWidget | ( | Point | pt,
|  | Point * | fieldxy,
|  | Point * | xy
| ) |  |
| inline

Calculate in which field was clicked, and within the field, at what position.

Parameters

  pt | Clicked position in the WID_IC_PANEL widget.
  fieldxy | If `true` is returned, field x/y coordinate of pt.
  xy | If `true` is returned, x/y coordinate with in the field.

Returns
  Clicked at a valid position.

Definition at line 3035 of file industry_gui.cpp.

References _current_text_dir, CargoesField::cargo_field_width, WidgetDimensions::frametext, Scrollbar::GetPosition(), Window::GetWidget(), CargoesField::industry_width, CargoesField::normal_height, NUM_INDUSTRYTYPES, WidgetDimensions::scaled, CargoesField::small_height, TD_RTL, WID_IC_PANEL, and Window::width.

Referenced by OnClick(), and OnTooltip().

## ◆ ComputeCargoDisplay()

void IndustryCargoesWindow::ComputeCargoDisplay | ( | CargoID | cid | ) |
| inline

Compute what and where to display for cargo id cid.

Parameters

  cid | Cargo id to display.

Definition at line 2906 of file industry_gui.cpp.

References _displayed_industries, _sorted_industry_types, CFT_EMPTY, CFT_SMALL_EMPTY, CargoesRow::columns, CountMatchingAcceptingIndustries(), CountMatchingProducingIndustries(), GetIndustrySpec(), Window::GetWidget(), HasCommonValidCargo(), HousesCanAccept(), HousesCanSupply(), CargoesField::MakeEmpty(), CargoesField::MakeHeader(), NotifySmallmap(), NUM_INDUSTRYTYPES, PlaceIndustry(), Scrollbar::SetCount(), Window::SetDirty(), ShortenCargoColumn(), and WID_IC_CAPTION.

Referenced by OnClick(), and OnDropdownSelect().

## ◆ ComputeIndustryDisplay()

void IndustryCargoesWindow::ComputeIndustryDisplay | ( | IndustryType | displayed_it | ) |
| inline

Compute what and where to display for industry type it.

Parameters

  displayed_it | Industry type to display.

Definition at line 2828 of file industry_gui.cpp.

References _displayed_industries, _sorted_industry_types, CFT_EMPTY, CFT_SMALL_EMPTY, CargoesRow::columns, CountMatchingAcceptingIndustries(), CountMatchingProducingIndustries(), GetIndustrySpec(), Window::GetWidget(), HasCommonValidCargo(), HousesCanAccept(), HousesCanSupply(), CargoesField::MakeEmpty(), CargoesField::MakeHeader(), NotifySmallmap(), NUM_INDUSTRYTYPES, PlaceIndustry(), Scrollbar::SetCount(), Window::SetDirty(), ShortenCargoColumn(), and WID_IC_CAPTION.

Referenced by OnClick(), OnDropdownSelect(), and OnInvalidateData().

## ◆ CountMatchingAcceptingIndustries()

static int IndustryCargoesWindow::CountMatchingAcceptingIndustries | ( | const std::span< const CargoID > | cargoes | ) |
| inlinestatic

Count how many industries have accepted cargoes in common with one of the supplied set.

Parameters

  cargoes | Cargoes to search.

Returns
  Number of industries that have an accepted cargo in common with the supplied set.

Definition at line 2745 of file industry_gui.cpp.

References GetIndustrySpec(), Window::GetWidget(), HasCommonValidCargo(), and NUM_INDUSTRYTYPES.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

## ◆ CountMatchingProducingIndustries()

static int IndustryCargoesWindow::CountMatchingProducingIndustries | ( | const std::span< const CargoID > | cargoes | ) |
| inlinestatic

Count how many industries have produced cargoes in common with one of the supplied set.

Parameters

  cargoes | Cargoes to search.

Returns
  Number of industries that have a produced cargo in common with the supplied set.

Definition at line 2762 of file industry_gui.cpp.

References GetIndustrySpec(), Window::GetWidget(), HasCommonValidCargo(), and NUM_INDUSTRYTYPES.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

## ◆ DrawWidget()

void IndustryCargoesWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 2989 of file industry_gui.cpp.

References _current_text_dir, WidgetDimensions::bevel, CargoesField::cargo_field_width, fields, FillDrawPixelInfo(), WidgetDimensions::frametext, Scrollbar::GetPosition(), Window::GetWidget(), Window::height, CargoesField::industry_width, CargoesField::normal_height, NUM_INDUSTRYTYPES, WidgetDimensions::scaled, Rect::Shrink(), CargoesField::small_height, TD_RTL, and WID_IC_PANEL.

## ◆ HasCommonValidCargo()

static bool IndustryCargoesWindow::HasCommonValidCargo | ( | const std::span< const CargoID > | cargoes1,
|  | const std::span< const CargoID > | cargoes2
| ) |  |
| inlinestatic

Do the two sets of cargoes have a valid cargo in common?

Parameters

  cargoes1 | Span of the first cargo list.
  cargoes2 | Span of the second cargo list.

Returns
  Arrays have at least one valid cargo in common.

Definition at line 2685 of file industry_gui.cpp.

References Window::GetWidget(), and IsValidCargoID().

Referenced by ComputeCargoDisplay(), ComputeIndustryDisplay(), CountMatchingAcceptingIndustries(), and CountMatchingProducingIndustries().

## ◆ HousesCanAccept()

static bool IndustryCargoesWindow::HousesCanAccept | ( | const std::span< const CargoID > | cargoes | ) |
| inlinestatic

Can houses be used as customers of the produced cargoes?

Parameters

  cargoes | Span of cargo list.

Returns
  Houses can accept at least one of the cargoes.

Definition at line 2716 of file industry_gui.cpp.

References _settings_game, GameSettings::game_creation, Window::GetWidget(), HZ_SUBARTC_ABOVE, HZ_SUBARTC_BELOW, HZ_SUBTROPIC, HZ_TEMP, HZ_TOYLND, IsValidCargoID(), GameCreationSettings::landscape, lengthof, and HouseSpec::Specs().

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

## ◆ HousesCanSupply()

static bool IndustryCargoesWindow::HousesCanSupply | ( | const std::span< const CargoID > | cargoes | ) |
| inlinestatic

Can houses be used to supply one of the cargoes?

Parameters

  cargoes | Span of cargo list.

Returns
  Houses can supply at least one of the cargoes.

Definition at line 2701 of file industry_gui.cpp.

References CargoSpec::Get(), Window::GetWidget(), IsValidCargoID(), CargoSpec::town_production_effect, TPE_MAIL, and TPE_PASSENGERS.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

## ◆ NotifySmallmap()

void IndustryCargoesWindow::NotifySmallmap | ( |  | ) |
| inline

Notify smallmap that new displayed industries have been selected (in _displayed_industries).

Definition at line 2815 of file industry_gui.cpp.

References InvalidateWindowClassesData(), Window::IsWidgetLowered(), WC_SMALLMAP, and WID_IC_NOTIFY.

Referenced by ComputeCargoDisplay(), ComputeIndustryDisplay(), and OnClick().

## ◆ OnClick()

void IndustryCargoesWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 3074 of file industry_gui.cpp.

References _settings_client, _sorted_industry_types, _sorted_standard_cargo_specs, CalculatePositionInWidget(), CFT_CARGO, CFT_CARGO_LABEL, CFT_INDUSTRY, SoundSettings::click_beep, ComputeCargoDisplay(), ComputeIndustryDisplay(), FindWindowByClass(), GetIndustrySpec(), GetLargestCargoIconSize(), Window::GetWidget(), ind_cargo, CargoesField::ind_type, CargoesField::industry, IsValidCargoID(), Window::IsWidgetLowered(), NotifySmallmap(), NUM_INDUSTRYTYPES, Window::SetWidgetDirty(), ShowDropDownList(), ShowSmallMap(), SND_15_BEEP, ClientSettings::sound, Window::ToggleWidgetLoweredState(), WC_SMALLMAP, WID_IC_CARGO_DROPDOWN, WID_IC_IND_DROPDOWN, WID_IC_NOTIFY, and WID_IC_PANEL.

## ◆ OnDropdownSelect()

void IndustryCargoesWindow::OnDropdownSelect | ( | WidgetID | widget,
|  | int | index
| ) |  |
| inlineoverridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 3147 of file industry_gui.cpp.

References ComputeCargoDisplay(), ComputeIndustryDisplay(), WID_IC_CARGO_DROPDOWN, and WID_IC_IND_DROPDOWN.

## ◆ OnInit()

void IndustryCargoesWindow::OnInit | ( |  | ) |
| inlineoverridevirtual

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note
  nested_root and/or widget_lookup (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 2578 of file industry_gui.cpp.

References CargoesField::blob_distance, CargoesField::cargo_border, CargoesField::cargo_field_width, CargoesField::cargo_line, CargoesField::cargo_space, CargoesField::cargo_stub, WidgetDimensions::frametext, FS_NORMAL, FS_SMALL, GetCharacterHeight(), GetIndustrySpec(), GetStringBoundingBox(), Window::GetWidget(), Window::height, RectPadding::Horizontal(), WidgetDimensions::hsep_normal, CargoesField::industry_width, IsValidCargoID(), CargoSpec::Iterate(), CargoesField::legend, CargoesField::max_cargoes, maxdim(), CargoesField::normal_height, NUM_INDUSTRYTYPES, WidgetDimensions::scaled, ScaleGUITrad(), CargoesField::small_height, CargoesField::vert_inter_industry_space, RectPadding::Vertical(), and WidgetDimensions::vsep_wide.

## ◆ OnInvalidateData()

void IndustryCargoesWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data. data = 0 .. NUM_INDUSTRYTYPES - 1: Display the chain around the given industry. data = NUM_INDUSTRYTYPES: Stop sending updates to the smallmap window.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 2977 of file industry_gui.cpp.

References ComputeIndustryDisplay(), Window::GetWidget(), NUM_INDUSTRYTYPES, Window::RaiseWidgetWhenLowered(), and WID_IC_NOTIFY.

## ◆ OnResize()

void IndustryCargoesWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 3203 of file industry_gui.cpp.

References WidgetDimensions::scaled, Scrollbar::SetCapacityFromWidget(), CargoesField::small_height, and WID_IC_PANEL.

## ◆ OnTooltip()

bool IndustryCargoesWindow::OnTooltip | ( | Point | pt,
|  | WidgetID | widget,
|  | TooltipCloseCondition | close_cond
| ) |  |
| inlineoverridevirtual

Event to display a custom tooltip.

Parameters

  pt | The point where the mouse is located.
  widget | The widget where the mouse is located.

Returns
  True if the event is handled, false if it is ignored.

Reimplemented from Window.

Definition at line 3162 of file industry_gui.cpp.

References CalculatePositionInWidget(), CFT_CARGO, CFT_CARGO_LABEL, CFT_INDUSTRY, CargoSpec::Get(), Window::GetWidget(), GuiShowTooltips(), IsValidCargoID(), NUM_INDUSTRYTYPES, SetDParam(), and WID_IC_PANEL.

## ◆ PlaceIndustry()

void IndustryCargoesWindow::PlaceIndustry | ( | int | row,
|  | int | col,
|  | IndustryType | it
| ) |  |
| inline

Place an industry in the fields.

Parameters

  row | Row of the new industry.
  col | Column of the new industry.
  it | Industry to place.

Definition at line 2801 of file industry_gui.cpp.

References CFT_EMPTY, and Window::GetWidget().

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

## ◆ SetStringParameters()

void IndustryCargoesWindow::SetStringParameters | ( | WidgetID | widget | ) | const
| inlineoverridevirtual

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.

Reimplemented from Window.

Definition at line 2666 of file industry_gui.cpp.

References CargoSpec::Get(), GetIndustrySpec(), Window::GetWidget(), NUM_INDUSTRYTYPES, SetDParam(), and WID_IC_CAPTION.

## ◆ ShortenCargoColumn()

void IndustryCargoesWindow::ShortenCargoColumn | ( | int | column,
|  | int | top,
|  | int | bottom
| ) |  |
| inline

Shorten the cargo column to just the part between industries.

Parameters

  column | Column number of the cargo column.
  top | Current top row.
  bottom | Current bottom row.

Definition at line 2780 of file industry_gui.cpp.

References CFT_EMPTY, fields, Window::GetWidget(), and Window::top.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

## ◆ UpdateWidgetSize()

void IndustryCargoesWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 2647 of file industry_gui.cpp.

References CargoesField::cargo_field_width, WidgetDimensions::frametext, Window::GetWidget(), RectPadding::Horizontal(), CargoesField::industry_width, CargoesField::normal_height, Window::resize, WidgetDimensions::scaled, CargoesField::small_height, RectPadding::Vertical(), WID_IC_CARGO_DROPDOWN, WID_IC_IND_DROPDOWN, and WID_IC_PANEL.

## Field Documentation

## ◆ cargo_textsize

Dimension IndustryCargoesWindow::cargo_textsize

Size to hold any cargo text, as well as STR_INDUSTRY_CARGOES_SELECT_CARGO.

Definition at line 2565 of file industry_gui.cpp.

## ◆ fields

Fields IndustryCargoesWindow::fields

Fields to display in the WID_IC_PANEL.

Definition at line 2563 of file industry_gui.cpp.

Referenced by DrawWidget(), and ShortenCargoColumn().

## ◆ ind_cargo

uint IndustryCargoesWindow::ind_cargo

If less than NUM_INDUSTRYTYPES, an industry type, else a cargo id + NUM_INDUSTRYTYPES.

Definition at line 2564 of file industry_gui.cpp.

Referenced by OnClick().

## ◆ ind_textsize

Dimension IndustryCargoesWindow::ind_textsize

Size to hold any industry type text, as well as STR_INDUSTRY_CARGOES_SELECT_INDUSTRY.

Definition at line 2566 of file industry_gui.cpp.

## ◆ vscroll

Scrollbar* IndustryCargoesWindow::vscroll

Definition at line 2567 of file industry_gui.cpp.

The documentation for this struct was generated from the following file:

- src/industry_gui.cpp